//
//  ViewController.m
//  MyDemo
//
//  Created by ZFJ on 2017/4/10.
//  Copyright © 2017年 ZFJ. All rights reserved.
//

#import "ViewController.h"

#define KTime   20//设置重新发送的时间  自己可以改

#define ScreenHeight   [UIScreen mainScreen].bounds.size.height
#define ScreenWidth    [UIScreen mainScreen].bounds.size.width

@interface ViewController (){
    NSTimer *_myTimer;//定时器
}

@property (nonatomic,strong) UIButton *sentCodeBtn;//发送验证码按钮
@property (nonatomic,assign) NSInteger timer;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    [self uiConfig];
}

- (void)uiConfig{
    _timer = KTime;
    self.sentCodeBtn.frame = CGRectMake((ScreenWidth - 120)/2, (ScreenWidth - 40)/2, 120, 40);
    [self refreshButtonView];
    [self.view addSubview:self.sentCodeBtn];
}

- (void)refreshButtonView{
    [self.sentCodeBtn setBackgroundImage:[self imageWithColor:[UIColor colorWithRed:1.000 green:0.310 blue:0.000 alpha:1.00] andSize:_sentCodeBtn.frame.size] forState:UIControlStateNormal];
    [self.sentCodeBtn setBackgroundImage:[self imageWithColor:[UIColor lightGrayColor] andSize:_sentCodeBtn.frame.size] forState:UIControlStateDisabled];
}

- (UIImage *)imageWithColor:(UIColor *)color andSize:(CGSize)aSize{
    CGRect rect = CGRectMake(0.0f, 0.0f, aSize.width, aSize.height);
    UIGraphicsBeginImageContext(rect.size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    CGContextSetFillColorWithColor(context, [color CGColor]);
    CGContextFillRect(context, rect);
    
    UIImage *image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return image;
}

- (void)sentCodeBtnClick:(UIButton *)button{
    button.enabled = NO;
    [self refreshButtonView];
    [button setTitle:[NSString stringWithFormat:@"获取验证码(%zi)", _timer] forState:UIControlStateNormal];
    
    _myTimer = [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(myTimer) userInfo:nil repeats:YES];
}

- (void)myTimer{
    [_sentCodeBtn setTitle:[NSString stringWithFormat:@"获取验证码(%zi)", _timer] forState:UIControlStateNormal];
    if (_timer == 0) {
        [self.sentCodeBtn setTitle:@"重新获取" forState:UIControlStateNormal];
        self.sentCodeBtn.enabled = YES;
        [self refreshButtonView];
        [_myTimer invalidate];
        _myTimer = nil;
        _timer = KTime;
    }else{
        _timer --;
    }
    
}

#pragma mark - 懒加载

- (UIButton *)sentCodeBtn{
    if(_sentCodeBtn == nil){
        _sentCodeBtn = [[UIButton alloc]init];
        [_sentCodeBtn setTitle:@"获取验证码" forState:UIControlStateNormal];
        [_sentCodeBtn.titleLabel setFont:[UIFont systemFontOfSize:14]];
        [_sentCodeBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_sentCodeBtn addTarget:self action:@selector(sentCodeBtnClick:) forControlEvents:UIControlEventTouchUpInside];
        _sentCodeBtn.enabled = YES;
        _sentCodeBtn.layer.masksToBounds = YES;
        _sentCodeBtn.layer.cornerRadius = 5;
    }
    return _sentCodeBtn;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
